<?
// Входни данни – три реда, съдържащи случайни данни.
// Използва се деление на 2 и 3, за да не припокриват
// предните редове със задните.

// Масивът $DATA["x"] съдържа надписите по оста "X"

$DATA=Array();
for ($i=0;$i<20;$i++) {
    $DATA[0][]=rand(0,100*$i);
    $DATA[1][]=rand(0,100*$i)/2;
    $DATA[2][]=rand(0,100*$i)/3;
    $DATA["x"][]=$i;
    }

// Функция за извеждане на псевдотриизмерен куб 

// $im – идентификатор на изображението
// $x,$y – координати на горния ляв ъгъл на куба
// $w – широчина на куба
// $h – височина на куба
// $dx – изместване на задната граница на куба по оста X
// $dy – изместване на задната граница на куба по оста Y
// $c1,$c2,c3 – цвят на видимите граници на куба

function imagebar($im,$x,$y,$w,$h,$dx,$dy,$c1,$c2,$c3) {

    if ($dx>0) {
        imagefilledpolygon($im,
            Array(
                $x, $y-$h,
                $x+$w, $y-$h,
                $x+$w+$dx, $y-$h-$dy,
                $x+$dx, $y-$dy-$h
            ), 4, $c1);
    
        imagefilledpolygon($im,
            Array(
                $x+$w, $y-$h,
                $x+$w, $y,
                $x+$w+$dx, $y-$dy,
                $x+$w+$dx, $y-$dy-$h
            ), 4, $c3);
        }

    imagefilledrectangle($im, $x, $y-$h, $x+$w, $y, $c2);
    }

// Създаваме променливи стойности 

// Размер на изображението
$W=500;
$H=300;

// Псевдодълбочина на графиката
$DX=30;
$DY=20;

// Отстъпи
$MB=20; // Долен
$ML=10; // Ляв 
$M=5;   // Горен и десен. Те са по-малки, тъй като там няма текст

// Широчина на един символ
$LW=imagefontwidth(2);

// Броим количеството на елементите (стълбовете) на графиката
$count=count($DATA[0]);
if (count($DATA[1])>$count) $count=count($DATA[1]);
if (count($DATA[2])>$count) $count=count($DATA[2]);

// Максимална стойност
$max=0;
for ($i=0;$i<$count;$i++) {
    $max=$max<$DATA[0][$i]?$DATA[0][$i]:$max;
    $max=$max<$DATA[1][$i]?$DATA[1][$i]:$max;
    $max=$max<$DATA[2][$i]?$DATA[2][$i]:$max;
    }

// Увеличаваме максималната стойност с 10% (така че стълбът, съответстващ
// на максималната стойност, да не опира в границата на графиката)

$max=intval($max+($max/10));

// Работа с изображение 

// Създаваме изображение
$im=imagecreate($W,$H);

// Задаваме основни цветове 

// Цвят на фона (бял)
$bg[0]=imagecolorallocate($im,255,255,255);

// Цвят на задната граница на графиката (светлосив)
$bg[1]=imagecolorallocate($im,231,231,231);

// Цвят на лявата граница на графиката (сив)
$bg[2]=imagecolorallocate($im,212,212,212);

// Цвят на мрежата (сив, тъмен)
$c=imagecolorallocate($im,184,184,184);

// Цвят на текста (тъмносив)
$text=imagecolorallocate($im,136,136,136);

// Цветове за стълбовете
$bar[2][0]=imagecolorallocate($im,255,128,234);
$bar[2][1]=imagecolorallocate($im,222,95,201);
$bar[2][2]=imagecolorallocate($im,191,65,170);
$bar[0][0]=imagecolorallocate($im,222,214,0);
$bar[0][1]=imagecolorallocate($im,181,187,65);
$bar[0][2]=imagecolorallocate($im,161,155,0);
$bar[1][0]=imagecolorallocate($im,128,234,255);
$bar[1][1]=imagecolorallocate($im,95,201,222);
$bar[1][2]=imagecolorallocate($im,65,170,191);

// Броят на надписите и хоризонталните линии по оста Y.
$county=10;

// Подравняваме лявата граница с оглед на широчината на надписите по оста Y
$text_width=strlen($max)*$LW;
$ML+=$text_width;

// Извеждане на фона на графиката
imageline($im, $ML, $M+$DY, $ML, $H-$MB, $c);
imageline($im, $ML, $M+$DY, $ML+$DX, $M, $c);
imageline($im, $ML, $H-$MB, $ML+$DX, $H-$MB-$DY, $c);
imageline($im, $ML, $H-$MB, $W-$M-$DX, $H-$MB, $c);
imageline($im, $W-$M-$DX, $H-$MB, $W-$M, $H-$MB-$DY, $c);

imagefilledrectangle($im, $ML+$DX, $M, $W-$M, $H-$MB-$DY, $bg[1]);
imagerectangle($im, $ML+$DX, $M, $W-$M, $H-$MB-$DY, $c);

imagefill($im, $ML+1, $H/2, $bg[2]);

// Извеждане на неизменяема решетка (хоризонтални и вертикални линии)

for ($i=1;$i<3;$i++) {
    imageline($im, $ML+$i*intval($DX/3),
                   $M+$DY-$i*intval($DY/3),
                   $ML+$i*intval($DX/3),
                   $H-$MB-$i*intval($DY/3),
                   $c);
    imageline($im, $ML+$i*intval($DX/3),
                   $H-$MB-$i*intval($DY/3),
                   $W-$M-$DX+$i*intval($DX/3),
                   $H-$MB-$i*intval($DY/3),
                   $c);
    }

// Пресмятаме размерите на графиката с оглед на надписите и отстъпите
$RW=$W-$ML-$M-$DX;
$RH=$H-$MB-$M-$DY;

// Координати на нулевата точка на графиката
$X0=$ML+$DX;
$Y0=$H-$MB-$DY;

// Извеждане на изменяема решетка (вертикални линии на долната граница на 
// графиката и вертикални линии на задната граница)
for ($i=0;$i<$count;$i++) {
    imageline($im,$X0+$i*($RW/$count),$Y0,$X0+$i*($RW/$count)-$DX,$Y0+$DY,$c);
    imageline($im,$X0+$i*($RW/$count),$Y0,$X0+$i*($RW/$count),$Y0-$RH,$c);
    }

// Хоризонтални линии на мрежата на задната и лявата граница.
$step=$RH/$county;
for ($i=0;$i<=$county;$i++) {
    imageline($im,$X0,$Y0-$step*$i,$X0+$RW,$Y0-$step*$i,$c);
    imageline($im,$X0,$Y0-$step*$i,$X0-$DX,$Y0-$step*$i+$DY,$c);
    imageline($im,$X0-$DX,$Y0-$step*$i+$DY,
                  $X0-$DX-($ML-$text_width)/4,$Y0-$step*$i+$DY,$text);
    }

// Извеждане на кубовете за трите реда
for ($i=0;$i<$count;$i++) 
    imagebar($im, $X0+$i*($RW/$count)+4-1*intval($DX/3),
                  $Y0+1*intval($DY/3),
                  intval($RW/$count)-4,
                  $RH/$max*$DATA[0][$i],
                  intval($DX/3)-5,
                  intval($DY/3)-3,
                  $bar[0][0], $bar[0][1], $bar[0][2]);

for ($i=0;$i<$count;$i++) 
    imagebar($im, $X0+$i*($RW/$count)+4-2*intval($DX/3),
                  $Y0+2*intval($DY/3),
                  intval($RW/$count)-4,
                  $RH/$max*$DATA[1][$i],
                  intval($DX/3)-5,
                  intval($DY/3)-3,
                  $bar[1][0], $bar[1][1], $bar[1][2]);

for ($i=0;$i<$count;$i++) 
    imagebar($im, $X0+$i*($RW/$count)+4-3*intval($DX/3), 
                  $Y0+3*intval($DY/3),
                  intval($RW/$count)-4,
                  $RH/$max*$DATA[2][$i],
                  intval($DX/3)-5,
                  intval($DY/3)-3,
                  $bar[2][0], $bar[2][1], $bar[2][2]);

// Извеждане на надписите по оста Y
for ($i=1;$i<=$county;$i++) {
    $str=intval(($max/$county)*$i);
    imagestring($im,2, $X0-$DX-strlen($str)*$LW-$ML/4-2,
                       $Y0+$DY-$step*$i-imagefontheight(2)/2,
                       $str,$text);
    }

// Извеждане на надписите по оста X
$prev=100000;
$twidth=$LW*strlen($DATA["x"][0])+6;
$i=$X0+$RW-$DX;

while ($i>$X0-$DX) {
    if ($prev-$twidth>$i) {
        $drawx=$i+1-($RW/$count)/2;
        if ($drawx>$X0-$DX) {
            $str=$DATA["x"][round(($i-$X0+$DX)/($RW/$count))-1];
            imageline($im,$drawx,$Y0+$DY,$i+1-($RW/$count)/2,$Y0+$DY+5,$text);
            imagestring($im,2, $drawx+1-(strlen($str)*$LW)/2 ,$Y0+$DY+7,$str,$text);
            }
        $prev=$i;
        }
    $i-=$RW/$count;
    }

header("Content-Type: image/png");

// Генериране на изображение
ImagePNG($im);

imagedestroy($im);
?>
