<?php

// Входни данни – три реда, съдържащи случайни данни.
// Делението на 2 и 3 е направено за по-голяма нагледност

// Масивът $DATA["x"] съдържа надписите по оста "X"

$DATA=Array();
for ($i=0;$i<20;$i++) {
    $DATA[0][]=rand(0,100);
    $DATA[1][]=rand(0,100)/2;
    $DATA[2][]=rand(0,100)/3;
    $DATA["x"][]=$i;
    }

// Задаваме променливи стойности 

// Размер на изображението (минимален размер 140х140)

$W=800;
$H=600;

// Отстъпи
$MB=20;  // Долен
$ML=8;   // Ляв 
$M=5;    // Горен и десен. Те са по-малки, тъй като там няма текст

// Широчината на един символ
$LW=imagefontwidth(2);

// Определяме броя на елементите (точките) на графиката
$count=count($DATA[0]);
if (count($DATA[1])>$count) $count=count($DATA[1]);
if (count($DATA[2])>$count) $count=count($DATA[2]);

if ($count==0) $count=1;

// Заглаждаме графиката 
if ($_GET["smooth"]==1) {

    // Добавяме по две точки отдясно и отляво на графиката. Стойностите в
    // тези точки ще приемем за равни на крайните. Например, ако точка
    // y[0]=16 и y[n]=17, то y[1]=16 и y[-2]=16 и y[n+1]=17 и y[n+2]=17

    // Такова добавяне на точки е необходимо за заглаждането на точките
    // в краищата на графиката

    for ($j=0;$j<3;$j++) {
        $DATA[$j][-1]=$DATA[$j][-2]=$DATA[$j][0];
        $DATA[$j][$count]=$DATA[$j][$count+1]=$DATA[$j][$count-1];
        }

    // Заглаждане на графиката по метода на усреднение 
    // на съседните стойности

    for ($i=0;$i<$count;$i++) {
        for ($j=0;$j<3;$j++) {
            $DATA[$j][$i]=($DATA[$j][$i-1]+$DATA[$j][$i-2]+
                           $DATA[$j][$i]+$DATA[$j][$i+1]+
                           $DATA[$j][$i+2])/5;
            }
        }
    }


// Изчисляваме максималната стойност 
$max=0;

for ($i=0;$i<$count;$i++) {
    $max=$max<$DATA[0][$i]?$DATA[0][$i]:$max;
    $max=$max<$DATA[1][$i]?$DATA[1][$i]:$max;
    $max=$max<$DATA[2][$i]?$DATA[2][$i]:$max;
    }

// Увеличаваме максималната стойност с 10% (така че стълбът, съответстващ
// на максималната стойност, да не опира в границата на графиката)

$max=intval($max+($max/10));

// Броят на надписите и хоризонталните линии по оста Y.
$county=10;

// Работа с изображение 

// Създаваме изображение
$im=imagecreate($W,$H);

// Цвят на фона (бял)
$bg[0]=imagecolorallocate($im,255,255,255);

// Цвят на задната граница на графиката (светлосив)
$bg[1]=imagecolorallocate($im,231,231,231);

// Цвят на лявата граница на графиката (сив)
$bg[2]=imagecolorallocate($im,212,212,212);

// Цвят на решетката (сив, тъмен)
$c=imagecolorallocate($im,184,184,184);

// Цвят на текста (тъмносив)
$text=imagecolorallocate($im,136,136,136);

// Цветове на линиите на графиките
$bar[2]=imagecolorallocate($im,191,65,170);
$bar[0]=imagecolorallocate($im,161,155,0);
$bar[1]=imagecolorallocate($im,65,170,191);

$text_width=0;
// Извеждане на надписите по оста Y
for ($i=1;$i<=$county;$i++) {
    $strl=strlen(($max/$county)*$i)*$LW;
    if ($strl>$text_width) $text_width=$strl;
    }

// Подравняваме левия край с оглед на широчината на надписите по оста Y
$ML+=$text_width;

// Изчисляваме реалните размери на графиката 
$RW=$W-$ML-$M;
$RH=$H-$MB-$M;

// Изчисляваме координатите на нулата
$X0=$ML;
$Y0=$H-$MB;

$step=$RH/$county;

// Извеждане на главната рамка на графиката
imagefilledrectangle($im, $X0, $Y0-$RH, $X0+$RW, $Y0, $bg[1]);
imagerectangle($im, $X0, $Y0, $X0+$RW, $Y0-$RH, $c);

// Извеждане на решетката по оста Y
for ($i=1;$i<=$county;$i++) {
    $y=$Y0-$step*$i;
    imageline($im,$X0,$y,$X0+$RW,$y,$c);
    imageline($im,$X0,$y,$X0-($ML-$text_width)/4,$y,$text);
    }

// Извеждане на решетката по оста X
// Извеждане на изменяема решетка
for ($i=0;$i<$count;$i++) {
    imageline($im,$X0+$i*($RW/$count),$Y0,$X0+$i*($RW/$count),$Y0,$c);
    imageline($im,$X0+$i*($RW/$count),$Y0,$X0+$i*($RW/$count),$Y0-$RH,$c);
    }

// Извеждане на линиите на графиката
$dx=($RW/$count)/2;

$pi=$Y0-($RH/$max*$DATA[0][0]);
$po=$Y0-($RH/$max*$DATA[1][0]);
$pu=$Y0-($RH/$max*$DATA[2][0]);
$px=intval($X0+$dx);

for ($i=1;$i<$count;$i++) {
    $x=intval($X0+$i*($RW/$count)+$dx);

    $y=$Y0-($RH/$max*$DATA[0][$i]);
    imageline($im,$px,$pi,$x,$y,$bar[0]);
    $pi=$y;

    $y=$Y0-($RH/$max*$DATA[1][$i]);
    imageline($im,$px,$po,$x,$y,$bar[1]);
    $po=$y;

    $y=$Y0-($RH/$max*$DATA[2][$i]);
    imageline($im,$px,$pu,$x,$y,$bar[2]);
    $pu=$y;
    $px=$x;
    }

// Намаляване и преизчисляване на координатите
$ML-=$text_width;

// Извеждане на надписите по оста Y
for ($i=1;$i<=$county;$i++) {
    $str=($max/$county)*$i;
    imagestring($im,2, $X0-strlen($str)*$LW-$ML/4-2,$Y0-$step*$i-
                       imagefontheight(2)/2,$str,$text);
    }

// Извеждане на надписите по оста X
$prev=100000;
$twidth=$LW*strlen($DATA["x"][0])+6;
$i=$X0+$RW;

while ($i>$X0) {
    if ($prev-$twidth>$i) {
        $drawx=$i-($RW/$count)/2;
        if ($drawx>$X0) {
            $str=$DATA["x"][round(($i-$X0)/($RW/$count))-1];
            imageline($im,$drawx,$Y0,$i-($RW/$count)/2,$Y0+5,$text);
            imagestring($im,2, $drawx-(strlen($str)*$LW)/2, $Y0+7,$str,$text);
            }
        $prev=$i;
        }
    $i-=$RW/$count;
    }

header("Content-Type: image/png");

// Генериране на изображението
ImagePNG($im);

imagedestroy($im);
?>
